Public Class clsPortChecker

#Region "PRIVATE VARIABLES"
    Private cStrHost As String
    Private cIntPort As Integer
    Private cBlnBusy As Boolean
    Private cFrmMain As frmMain
#End Region

#Region "CLASS EVENTS"
    Public Sub New(ByRef iCaller As Form, ByVal iHost As String, ByVal iPort As Integer)
        cFrmMain = iCaller
        host = iHost
        port = iPort
    End Sub
#End Region

#Region "PROPERTIES"
    Public Property host()
        Get
            host = cStrHost
        End Get
        Set(ByVal Value)
            cStrHost = Value
        End Set
    End Property
    Public Property port()
        Get
            port = cIntPort
        End Get
        Set(ByVal Value)
            cIntPort = Value
        End Set
    End Property
    Public ReadOnly Property busy()
        Get
            busy = cBlnBusy
        End Get
    End Property
#End Region

#Region "MAIN INTERFACE"
    Public Sub checkPort()
        cBlnBusy = True
        Dim hostadd As System.Net.IPAddress = System.Net.Dns.Resolve(host).AddressList(0)
        Dim EPhost As New System.Net.IPEndPoint(hostadd, port)
        Dim s As New System.Net.Sockets.Socket(System.Net.Sockets.AddressFamily.InterNetwork, System.Net.Sockets.SocketType.Stream, System.Net.Sockets.ProtocolType.Tcp)
        Try
            s.Connect(EPhost)
            If Not s.Connected Then
                Call cFrmMain.reportPort(port, False)
                cBlnBusy = False
                Return
            Else
                Call cFrmMain.reportPort(port, True)
                cBlnBusy = False
                Return
            End If
        Catch
            Call cFrmMain.reportPort(port, False)
            cBlnBusy = False
            Return
        End Try
    End Sub
#End Region

End Class
